Index: uspace/srv/net/ethip/pdu.c
===================================================================
--- uspace/srv/net/ethip/pdu.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/ethip/pdu.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -46,6 +46,4 @@
 #include "pdu.h"
 
-#define MAC48_BYTES 6
-
 /** Encode Ethernet PDU. */
 int eth_pdu_encode(eth_frame_t *frame, void **rdata, size_t *rsize)
Index: uspace/srv/net/inetsrv/addrobj.c
===================================================================
--- uspace/srv/net/inetsrv/addrobj.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/inetsrv/addrobj.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -119,9 +119,21 @@
 		    inet_addrobj_t, addr_list);
 		
-		if (inet_naddr_compare_mask(&naddr->naddr, addr)) {
-			fibril_mutex_unlock(&addr_list_lock);
-			log_msg(LOG_DEFAULT, LVL_DEBUG, "inet_addrobj_find: found %p",
-			    naddr);
-			return naddr;
+		switch (find) {
+		case iaf_net:
+			if (inet_naddr_compare_mask(&naddr->naddr, addr)) {
+				fibril_mutex_unlock(&addr_list_lock);
+				log_msg(LOG_DEFAULT, LVL_DEBUG, "inet_addrobj_find: found %p",
+				    naddr);
+				return naddr;
+			}
+			break;
+		case iaf_addr:
+			if (inet_naddr_compare(&naddr->naddr, addr)) {
+				fibril_mutex_unlock(&addr_list_lock);
+				log_msg(LOG_DEFAULT, LVL_DEBUG, "inet_addrobj_find: found %p",
+				    naddr);
+				return naddr;
+			}
+			break;
 		}
 	}
Index: uspace/srv/net/inetsrv/icmpv6.c
===================================================================
--- uspace/srv/net/inetsrv/icmpv6.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/inetsrv/icmpv6.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -78,5 +78,5 @@
 	inet_dgram_t rdgram;
 	
-	rdgram.src = dgram->dest;
+	inet_get_srcaddr(&dgram->src, 0, &rdgram.src);
 	rdgram.dest = dgram->src;
 	rdgram.tos = 0;
@@ -150,7 +150,5 @@
 	case ICMPV6_NEIGHBOUR_SOLICITATION:
 	case ICMPV6_NEIGHBOUR_ADVERTISEMENT:
-#ifdef ACCEPT_RA
 	case ICMPV6_ROUTER_ADVERTISEMENT:
-#endif
 		return ndp_received(dgram);
 	default:
Index: uspace/srv/net/inetsrv/inet_link.c
===================================================================
--- uspace/srv/net/inetsrv/inet_link.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/inetsrv/inet_link.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -51,4 +51,7 @@
 static bool first_link = true;
 static bool first_link6 = true;
+
+static FIBRIL_MUTEX_INITIALIZE(ip_ident_lock);
+static uint16_t ip_ident = 0;
 
 static int inet_link_open(service_id_t);
@@ -335,5 +338,19 @@
 }
 
-/** Send IPv4 datagram over Internet link */
+/** Send IPv4 datagram over Internet link
+ *
+ * @param ilink Internet link
+ * @param lsrc  Source IPv4 address
+ * @param ldest Destination IPv4 address
+ * @param dgram IPv4 datagram body
+ * @param proto Protocol
+ * @param ttl   Time-to-live
+ * @param df    Do-not-Fragment flag
+ *
+ * @return EOK on success
+ * @return ENOMEM when not enough memory to create the datagram
+ * @return ENOTSUP if networking mode is not supported
+ *
+ */
 int inet_link_send_dgram(inet_link_t *ilink, addr32_t lsrc, addr32_t ldest,
     inet_dgram_t *dgram, uint8_t proto, uint8_t ttl, int df)
@@ -366,10 +383,16 @@
 	packet.proto = proto;
 	packet.ttl = ttl;
+	
+	/* Allocate identifier */
+	fibril_mutex_lock(&ip_ident_lock);
+	packet.ident = ++ip_ident;
+	fibril_mutex_unlock(&ip_ident_lock);
+	
 	packet.df = df;
 	packet.data = dgram->data;
 	packet.size = dgram->size;
 	
+	int rc;
 	size_t offs = 0;
-	int rc;
 	
 	do {
@@ -392,5 +415,17 @@
 }
 
-/** Send IPv6 datagram over Internet link */
+/** Send IPv6 datagram over Internet link
+ *
+ * @param ilink Internet link
+ * @param ldest Destination MAC address
+ * @param dgram IPv6 datagram body
+ * @param proto Next header
+ * @param ttl   Hop limit
+ * @param df    Do-not-Fragment flag (unused)
+ *
+ * @return EOK on success
+ * @return ENOMEM when not enough memory to create the datagram
+ *
+ */
 int inet_link_send_dgram6(inet_link_t *ilink, addr48_t ldest,
     inet_dgram_t *dgram, uint8_t proto, uint8_t ttl, int df)
@@ -421,4 +456,10 @@
 	packet.proto = proto;
 	packet.ttl = ttl;
+	
+	/* Allocate identifier */
+	fibril_mutex_lock(&ip_ident_lock);
+	packet.ident = ++ip_ident;
+	fibril_mutex_unlock(&ip_ident_lock);
+	
 	packet.df = df;
 	packet.data = dgram->data;
Index: uspace/srv/net/inetsrv/inet_std.h
===================================================================
--- uspace/srv/net/inetsrv/inet_std.h	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/inetsrv/inet_std.h	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -40,4 +40,6 @@
 #include <sys/types.h>
 
+#define IP6_NEXT_FRAGMENT  44
+
 /** IPv4 Datagram header (fixed part) */
 typedef struct {
@@ -48,5 +50,5 @@
 	/** Total Length */
 	uint16_t tot_len;
-	/** Identification */
+	/** Identifier */
 	uint16_t id;
 	/** Flags, Fragment Offset */
@@ -90,4 +92,14 @@
 };
 
+/** Bits in ip6_header_fragment_t.offsmf */
+enum flags_offsmt_bits {
+	/** More fragments */
+	OF_FLAG_M = 0,
+	/** Fragment offset, highest bit */
+	OF_FRAGOFF_h = 15,
+	/** Fragment offset, lowest bit */
+	OF_FRAGOFF_l = 3
+};
+
 /** IPv6 Datagram header (fixed part) */
 typedef struct {
@@ -114,7 +126,7 @@
 	/** Reserved */
 	uint8_t reserved;
-	/** Fragment Offset, Flags */
-	uint16_t foff_flags;
-	/** Identification */
+	/** Fragmentation offset, reserved and M flag */
+	uint16_t offsmf;
+	/** Identifier */
 	uint32_t id;
 } ip6_header_fragment_t;
Index: uspace/srv/net/inetsrv/inetsrv.c
===================================================================
--- uspace/srv/net/inetsrv/inetsrv.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/inetsrv/inetsrv.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -62,4 +62,15 @@
 #define NAME "inetsrv"
 
+static inet_naddr_t solicited_node_mask = {
+	.family = AF_INET6,
+	.addr6 = {0xff, 0x02, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0x01, 0xff, 0, 0, 0},
+	.prefix = 104
+};
+
+static inet_addr_t multicast_all_nodes = {
+	.family = AF_INET6,
+	.addr6 = {0xff, 0x02, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0x01}
+};
+
 static void inet_client_conn(ipc_callid_t iid, ipc_call_t *icall, void *arg);
 
@@ -514,5 +525,7 @@
 
 	addr = inet_addrobj_find(&packet->dest, iaf_addr);
-	if (addr != NULL) {
+	if ((addr != NULL) ||
+	    (inet_naddr_compare_mask(&solicited_node_mask, &packet->dest)) ||
+	    (inet_addr_compare(&multicast_all_nodes, &packet->dest))) {
 		/* Destined for one of the local addresses */
 
Index: uspace/srv/net/inetsrv/inetsrv.h
===================================================================
--- uspace/srv/net/inetsrv/inetsrv.h	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/inetsrv/inetsrv.h	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -113,5 +113,5 @@
 	uint8_t ttl;
 	/** Identifier */
-	uint16_t ident;
+	uint32_t ident;
 	/** Do not fragment */
 	bool df;
Index: uspace/srv/net/inetsrv/ndp.c
===================================================================
--- uspace/srv/net/inetsrv/ndp.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/inetsrv/ndp.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -38,4 +38,5 @@
 #include <mem.h>
 #include <malloc.h>
+#include <io/log.h>
 #include <net/socket_codes.h>
 #include "ntrans.h"
@@ -48,16 +49,13 @@
 #define NDP_REQUEST_TIMEOUT  (3 * 1000 * 1000)
 
-static addr48_t solicited_node_mac =
-    {0x33, 0x33, 0xff, 0, 0, 0};
-
 static addr128_t solicited_node_ip =
     {0xff, 0x02, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0x01, 0xff, 0, 0, 0};
 
-static void ndp_solicited_node_mac(addr128_t ip_addr, addr48_t mac_addr)
-{
-	memcpy(mac_addr, solicited_node_mac, 3);
-	memcpy(mac_addr + 3, ip_addr + 13, 3);
-}
-
+/** Compute solicited node IPv6 multicast address from target IPv6 address
+ *
+ * @param ip_addr      Target IPv6 address
+ * @param ip_solicited Solicited IPv6 address to be assigned
+ *
+ */
 static void ndp_solicited_node_ip(addr128_t ip_addr,
     addr128_t ip_solicited)
@@ -88,4 +86,6 @@
 int ndp_received(inet_dgram_t *dgram)
 {
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "ndp_received()");
+	
 	ndp_packet_t packet;
 	int rc = ndp_pdu_decode(dgram, &packet);
@@ -100,4 +100,7 @@
 	
 	inet_addrobj_t *laddr;
+	
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "NDP PDU decoded; opcode: %d",
+	    packet.opcode);
 	
 	switch (packet.opcode) {
@@ -138,4 +141,15 @@
 }
 
+/** Translate IPv6 to MAC address
+ *
+ * @param src  Source IPv6 address
+ * @param dest Destination IPv6 address
+ * @param mac  Target MAC address to be assigned
+ * @param link Network interface
+ *
+ * @return EOK on success
+ * @return ENOENT when NDP translation failed
+ *
+ */
 int ndp_translate(addr128_t src_addr, addr128_t ip_addr, addr48_t mac_addr,
     inet_link_t *ilink)
@@ -157,5 +171,5 @@
 	addr128(src_addr, packet.sender_proto_addr);
 	addr128(ip_addr, packet.solicited_ip);
-	ndp_solicited_node_mac(ip_addr, packet.target_hw_addr);
+	addr48_solicited_node(ip_addr, packet.target_hw_addr);
 	ndp_solicited_node_ip(ip_addr, packet.target_proto_addr);
 	
Index: uspace/srv/net/inetsrv/ntrans.c
===================================================================
--- uspace/srv/net/inetsrv/ntrans.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/inetsrv/ntrans.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -47,4 +47,11 @@
 static FIBRIL_CONDVAR_INITIALIZE(ntrans_cv);
 
+/** Look for address in translation table
+ *
+ * @param ip_addr IPv6 address
+ *
+ * @return inet_ntrans_t with the address on success
+ * @return NULL if nothing found
+ */
 static inet_ntrans_t *ntrans_find(addr128_t ip_addr)
 {
@@ -60,4 +67,13 @@
 }
 
+/** Add entry to translation table
+ *
+ * @param ip_addr  IPv6 address of the new entry
+ * @param mac_addr MAC address of the new entry
+ *
+ * @return EOK on success
+ * @return ENOMEM if not enough memory
+ *
+ */
 int ntrans_add(addr128_t ip_addr, addr48_t mac_addr)
 {
@@ -86,4 +102,12 @@
 }
 
+/** Remove entry from translation table
+ *
+ * @param ip_addr IPv6 address of the entry to be removed
+ *
+ * @return EOK on success
+ * @return ENOENT when no such address found
+ *
+ */
 int ntrans_remove(addr128_t ip_addr)
 {
@@ -104,4 +128,13 @@
 }
 
+/** Translate IPv6 address to MAC address using the translation table
+ *
+ * @param ip_addr  IPv6 address to be translated
+ * @param mac_addr MAC address to be assigned
+ *
+ * @return EOK on success
+ * @return ENOENT when no such address found
+ *
+ */
 int ntrans_lookup(addr128_t ip_addr, addr48_t mac_addr)
 {
@@ -118,4 +151,12 @@
 }
 
+/** Wait on translation table CV for some time
+ *
+ * @param timeout Timeout in microseconds
+ *
+ * @return EOK if woken up by another fibril
+ * @return ETIMEDOUT if timed out
+ *
+ */
 int ntrans_wait_timeout(suseconds_t timeout)
 {
Index: uspace/srv/net/inetsrv/pdu.c
===================================================================
--- uspace/srv/net/inetsrv/pdu.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/inetsrv/pdu.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -49,7 +49,4 @@
 #include "pdu.h"
 
-static FIBRIL_MUTEX_INITIALIZE(ip_ident_lock);
-static uint16_t ip_ident = 0;
-
 /** One's complement addition.
  *
@@ -107,5 +104,5 @@
  */
 int inet_pdu_encode(inet_packet_t *packet, addr32_t src, addr32_t dest,
-   size_t offs, size_t mtu, void **rdata, size_t *rsize, size_t *roffs)
+    size_t offs, size_t mtu, void **rdata, size_t *rsize, size_t *roffs)
 {
 	/* Upper bound for fragment offset field */
@@ -117,7 +114,8 @@
 	
 	size_t hdr_size = sizeof(ip_header_t);
-	
-	size_t data_offs = ROUND_UP(hdr_size, 4);
-	
+	if (hdr_size >= mtu)
+		return EINVAL;
+	
+	assert(hdr_size % 4 == 0);
 	assert(offs % FRAG_OFFS_UNIT == 0);
 	assert(offs / FRAG_OFFS_UNIT < fragoff_limit);
@@ -125,7 +123,4 @@
 	/* Value for the fragment offset field */
 	uint16_t foff = offs / FRAG_OFFS_UNIT;
-	
-	if (hdr_size >= mtu)
-		return EINVAL;
 	
 	/* Amount of space in the PDU available for payload */
@@ -152,9 +147,4 @@
 		return ENOMEM;
 	
-	/* Allocate identifier */
-	fibril_mutex_lock(&ip_ident_lock);
-	uint16_t ident = ++ip_ident;
-	fibril_mutex_unlock(&ip_ident_lock);
-	
 	/* Encode header fields */
 	ip_header_t *hdr = (ip_header_t *) data;
@@ -164,5 +154,5 @@
 	hdr->tos = packet->tos;
 	hdr->tot_len = host2uint16_t_be(size);
-	hdr->id = host2uint16_t_be(ident);
+	hdr->id = host2uint16_t_be(packet->ident);
 	hdr->flags_foff = host2uint16_t_be(flags_foff);
 	hdr->ttl = packet->ttl;
@@ -178,5 +168,5 @@
 	
 	/* Copy payload */
-	memcpy((uint8_t *) data + data_offs, packet->data + offs, xfer_size);
+	memcpy((uint8_t *) data + hdr_size, packet->data + offs, xfer_size);
 	
 	*rdata = data;
@@ -202,5 +192,5 @@
  * @param rdata  Place to store pointer to allocated data buffer
  * @param rsize  Place to store size of allocated data buffer
- * @param roffs Place to store offset of remaning data
+ * @param roffs  Place to store offset of remaning data
  *
  */
@@ -208,6 +198,10 @@
     size_t offs, size_t mtu, void **rdata, size_t *rsize, size_t *roffs)
 {
+	/* IPv6 mandates a minimal MTU of 1280 bytes */
+	if (mtu < 1280)
+		return ELIMIT;
+	
 	/* Upper bound for fragment offset field */
-	size_t fragoff_limit = 1 << (FF_FRAGOFF_h - FF_FRAGOFF_l);
+	size_t fragoff_limit = 1 << (OF_FRAGOFF_h - OF_FRAGOFF_l);
 	
 	/* Verify that total size of datagram is within reasonable bounds */
@@ -215,20 +209,27 @@
 		return ELIMIT;
 	
-	size_t hdr_size = sizeof(ip6_header_t);
-	
-	size_t data_offs = ROUND_UP(hdr_size, 4);
-	
+	/* Determine whether we need the Fragment extension header */
+	bool fragment;
+	if (offs == 0)
+		fragment = (packet->size + sizeof(ip6_header_t) > mtu);
+	else
+		fragment = true;
+	
+	size_t hdr_size;
+	if (fragment)
+		hdr_size = sizeof(ip6_header_t) + sizeof(ip6_header_fragment_t);
+	else
+		hdr_size = sizeof(ip6_header_t);
+	
+	if (hdr_size >= mtu)
+		return EINVAL;
+	
+	assert(sizeof(ip6_header_t) % 8 == 0);
+	assert(hdr_size % 8 == 0);
 	assert(offs % FRAG_OFFS_UNIT == 0);
 	assert(offs / FRAG_OFFS_UNIT < fragoff_limit);
 	
-#if 0
-	// FIXME TODO fragmentation
-	
 	/* Value for the fragment offset field */
 	uint16_t foff = offs / FRAG_OFFS_UNIT;
-#endif
-	
-	if (hdr_size >= mtu)
-		return EINVAL;
 	
 	/* Amount of space in the PDU available for payload */
@@ -245,13 +246,8 @@
 	size_t rem_offs = offs + xfer_size;
 	
-#if 0
-	// FIXME TODO fragmentation
-	
 	/* Flags */
-	uint16_t flags_foff =
-	    (packet->df ? BIT_V(uint16_t, FF_FLAG_DF) : 0) +
-	    (rem_offs < packet->size ? BIT_V(uint16_t, FF_FLAG_MF) : 0) +
-	    (foff << FF_FRAGOFF_l);
-#endif
+	uint16_t offsmf =
+	    (rem_offs < packet->size ? BIT_V(uint16_t, OF_FLAG_M) : 0) +
+	    (foff << OF_FRAGOFF_l);
 	
 	void *data = calloc(size, 1);
@@ -259,13 +255,4 @@
 		return ENOMEM;
 	
-#if 0
-	// FIXME TODO fragmentation
-	
-	/* Allocate identifier */
-	fibril_mutex_lock(&ip_ident_lock);
-	uint16_t ident = ++ip_ident;
-	fibril_mutex_unlock(&ip_ident_lock);
-#endif
-	
 	/* Encode header fields */
 	ip6_header_t *hdr6 = (ip6_header_t *) data;
@@ -273,6 +260,4 @@
 	hdr6->ver_tc = (6 << (VI_VERSION_l));
 	memset(hdr6->tc_fl, 0, 3);
-	hdr6->payload_len = host2uint16_t_be(packet->size);
-	hdr6->next = packet->proto;
 	hdr6->hop_limit = packet->ttl;
 	
@@ -280,6 +265,28 @@
 	host2addr128_t_be(dest, hdr6->dest_addr);
 	
+	/* Optionally encode Fragment extension header fields */
+	if (fragment) {
+		assert(offsmf != 0);
+		
+		hdr6->payload_len = host2uint16_t_be(packet->size +
+		    sizeof(ip6_header_fragment_t));
+		hdr6->next = IP6_NEXT_FRAGMENT;
+		
+		ip6_header_fragment_t *hdr6f = (ip6_header_fragment_t *)
+		    (hdr6 + 1);
+		
+		hdr6f->next = packet->proto;
+		hdr6f->reserved = 0;
+		hdr6f->offsmf = host2uint16_t_be(offsmf);
+		hdr6f->id = host2uint32_t_be(packet->ident);
+	} else {
+		assert(offsmf == 0);
+		
+		hdr6->payload_len = host2uint16_t_be(packet->size);
+		hdr6->next = packet->proto;
+	}
+	
 	/* Copy payload */
-	memcpy((uint8_t *) data + data_offs, packet->data + offs, xfer_size);
+	memcpy((uint8_t *) data + hdr_size, packet->data + offs, xfer_size);
 	
 	*rdata = data;
@@ -290,4 +297,15 @@
 }
 
+/** Decode IPv4 datagram
+ *
+ * @param data   Serialized IPv4 datagram
+ * @param size   Length of serialized IPv4 datagram
+ * @param packet IP datagram structure to be filled
+ *
+ * @return EOK on success
+ * @return EINVAL if the datagram is invalid or damaged
+ * @return ENOMEM if not enough memory
+ *
+ */
 int inet_pdu_decode(void *data, size_t size, inet_packet_t *packet)
 {
@@ -353,4 +371,15 @@
 }
 
+/** Decode IPv6 datagram
+ *
+ * @param data   Serialized IPv6 datagram
+ * @param size   Length of serialized IPv6 datagram
+ * @param packet IP datagram structure to be filled
+ *
+ * @return EOK on success
+ * @return EINVAL if the datagram is invalid or damaged
+ * @return ENOMEM if not enough memory
+ *
+ */
 int inet_pdu_decode6(void *data, size_t size, inet_packet_t *packet)
 {
@@ -373,19 +402,33 @@
 	size_t payload_len = uint16_t_be2host(hdr6->payload_len);
 	if (payload_len + sizeof(ip6_header_t) > size) {
-		log_msg(LOG_DEFAULT, LVL_DEBUG, "Total Length = %zu > PDU size = %zu",
+		log_msg(LOG_DEFAULT, LVL_DEBUG, "Payload Length = %zu > PDU size = %zu",
 		    payload_len + sizeof(ip6_header_t), size);
 		return EINVAL;
 	}
 	
-#if 0
-	// FIXME TODO fragmentation
-	
-	uint16_t ident = uint16_t_be2host(hdr->id);
-	uint16_t flags_foff = uint16_t_be2host(hdr->flags_foff);
-	uint16_t foff = BIT_RANGE_EXTRACT(uint16_t, FF_FRAGOFF_h, FF_FRAGOFF_l,
-	    flags_foff);
-#endif
-	
-	/* XXX Checksum */
+	uint32_t ident;
+	uint16_t offsmf;
+	uint16_t foff;
+	uint16_t next;
+	size_t data_offs = sizeof(ip6_header_t);
+	
+	/* Fragment extension header */
+	if (hdr6->next == IP6_NEXT_FRAGMENT) {
+		ip6_header_fragment_t *hdr6f = (ip6_header_fragment_t *)
+		    (hdr6 + 1);
+		
+		ident = uint32_t_be2host(hdr6f->id);
+		offsmf = uint16_t_be2host(hdr6f->offsmf);
+		foff = BIT_RANGE_EXTRACT(uint16_t, OF_FRAGOFF_h, OF_FRAGOFF_l,
+		    offsmf);
+		next = hdr6f->next;
+		data_offs += sizeof(ip6_header_fragment_t);
+		payload_len -= sizeof(ip6_header_fragment_t);
+	} else {
+		ident = 0;
+		offsmf = 0;
+		foff = 0;
+		next = hdr6->next;
+	}
 	
 	addr128_t src;
@@ -399,24 +442,11 @@
 	
 	packet->tos = 0;
-	packet->proto = hdr6->next;
+	packet->proto = next;
 	packet->ttl = hdr6->hop_limit;
-	
-#if 0
-	// FIXME TODO fragmentation
-	
 	packet->ident = ident;
-	packet->df = (flags_foff & BIT_V(uint16_t, FF_FLAG_DF)) != 0;
-	packet->mf = (flags_foff & BIT_V(uint16_t, FF_FLAG_MF)) != 0;
+	
+	packet->df = 1;
+	packet->mf = (offsmf & BIT_V(uint16_t, OF_FLAG_M)) != 0;
 	packet->offs = foff * FRAG_OFFS_UNIT;
-	
-	/* XXX IP options */
-	size_t data_offs = sizeof(uint32_t) *
-	    BIT_RANGE_EXTRACT(uint8_t, VI_IHL_h, VI_IHL_l, hdr->ver_ihl);
-#endif
-	
-	packet->ident = 0;
-	packet->df = 0;
-	packet->mf = 0;
-	packet->offs = 0;
 	
 	packet->size = payload_len;
@@ -427,9 +457,17 @@
 	}
 	
-	memcpy(packet->data, (uint8_t *) data + sizeof(ip6_header_t), packet->size);
+	memcpy(packet->data, (uint8_t *) data + data_offs, packet->size);
 	
 	return EOK;
 }
 
+/** Encode NDP packet
+ *
+ * @param ndp   NDP packet structure to be serialized
+ * @param dgram IPv6 datagram structure to be filled
+ *
+ * @return EOK on success
+ *
+ */
 int ndp_pdu_encode(ndp_packet_t *ndp, inet_dgram_t *dgram)
 {
@@ -484,4 +522,13 @@
 }
 
+/** Decode NDP packet
+ *
+ * @param dgram Incoming IPv6 datagram encapsulating NDP packet
+ * @param ndp   NDP packet structure to be filled
+ *
+ * @return EOK on success
+ * @return EINVAL if the Datagram is invalid
+ *
+ */
 int ndp_pdu_decode(inet_dgram_t *dgram, ndp_packet_t *ndp)
 {
Index: uspace/srv/net/inetsrv/reass.c
===================================================================
--- uspace/srv/net/inetsrv/reass.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/inetsrv/reass.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -164,5 +164,5 @@
 		return NULL;
 
-	link_initialize(&rdg->map_link);
+	list_append(&rdg->map_link, &reass_dgram_map);
 	list_initialize(&rdg->frags);
 
Index: uspace/srv/net/tcp/conn.c
===================================================================
--- uspace/srv/net/tcp/conn.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/tcp/conn.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -312,4 +312,7 @@
 static bool tcp_socket_match(tcp_sock_t *sock, tcp_sock_t *patt)
 {
+	log_msg(LOG_DEFAULT, LVL_DEBUG2,
+	    "tcp_socket_match(sock=(%u), pat=(%u))", sock->port, patt->port);
+	
 	if ((!inet_addr_is_any(&patt->addr)) &&
 	    (!inet_addr_compare(&patt->addr, &sock->addr)))
@@ -351,4 +354,7 @@
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_conn_find_ref(%p)", sp);
+	
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "compare conn (f:(%u), l:(%u))",
+	    sp->foreign.port, sp->local.port);
 	
 	fibril_mutex_lock(&conn_list_lock);
@@ -357,4 +363,7 @@
 		tcp_conn_t *conn = list_get_instance(link, tcp_conn_t, link);
 		tcp_sockpair_t *csp = &conn->ident;
+		
+		log_msg(LOG_DEFAULT, LVL_DEBUG2, " - with (f:(%u), l:(%u))",
+		    csp->foreign.port, csp->local.port);
 		
 		if (tcp_sockpair_match(sp, csp)) {
Index: uspace/srv/net/tcp/sock.c
===================================================================
--- uspace/srv/net/tcp/sock.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/tcp/sock.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -613,7 +613,12 @@
 	ipc_callid_t wcallid;
 	size_t length;
-	uint8_t buffer[TCP_SOCK_FRAGMENT_SIZE];
 	tcp_error_t trc;
 	int rc;
+	
+	uint8_t *buffer = calloc(TCP_SOCK_FRAGMENT_SIZE, 1);
+	if (buffer == NULL) {
+		async_answer_0(callid, ENOMEM);
+		return;
+	}
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_sock_send()");
@@ -625,5 +630,5 @@
 	if (sock_core == NULL) {
 		async_answer_0(callid, ENOTSOCK);
-		return;
+		goto out;
 	}
 
@@ -641,5 +646,5 @@
 			fibril_mutex_unlock(&socket->lock);
 			async_answer_0(callid, EINVAL);
-			return;
+			goto out;
 		}
 
@@ -651,5 +656,5 @@
 			fibril_mutex_unlock(&socket->lock);
 			async_answer_0(callid, rc);
-			return;
+			goto out;
 		}
 
@@ -676,5 +681,5 @@
 			fibril_mutex_unlock(&socket->lock);
 			async_answer_0(callid, rc);
-			return;
+			goto out;
 		}
 	}
@@ -685,4 +690,7 @@
 	    IPC_GET_ARG2(answer));
 	fibril_mutex_unlock(&socket->lock);
+	
+out:
+	free(buffer);
 }
 
Index: uspace/srv/net/tcp/tcp.c
===================================================================
--- uspace/srv/net/tcp/tcp.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/tcp/tcp.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -54,6 +54,4 @@
 #define NAME       "tcp"
 
-#define IP_PROTO_TCP 6
-
 static int tcp_inet_ev_recv(inet_dgram_t *dgram);
 static void tcp_received_pdu(tcp_pdu_t *pdu);
Index: uspace/srv/net/tcp/tqueue.c
===================================================================
--- uspace/srv/net/tcp/tqueue.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/tcp/tqueue.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -282,4 +282,8 @@
 void tcp_transmit_segment(tcp_sockpair_t *sp, tcp_segment_t *seg)
 {
+	log_msg(LOG_DEFAULT, LVL_DEBUG,
+	    "tcp_transmit_segment(f:(%u),l:(%u), %p)",
+	    sp->local.port, sp->foreign.port, seg);
+	
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "SEG.SEQ=%" PRIu32 ", SEG.WND=%" PRIu32,
 	    seg->seq, seg->wnd);
Index: uspace/srv/net/tcp/ucall.c
===================================================================
--- uspace/srv/net/tcp/ucall.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/tcp/ucall.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -298,4 +298,8 @@
 	tcp_conn_t *conn;
 
+	log_msg(LOG_DEFAULT, LVL_DEBUG,
+	    "tcp_as_segment_arrived(f:(%u), l:(%u))",
+	    sp->foreign.port, sp->local.port);
+
 	conn = tcp_conn_find_ref(sp);
 	if (conn == NULL) {
Index: uspace/srv/net/udp/assoc.c
===================================================================
--- uspace/srv/net/udp/assoc.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/udp/assoc.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -372,4 +372,7 @@
 static bool udp_socket_match(udp_sock_t *sock, udp_sock_t *patt)
 {
+	log_msg(LOG_DEFAULT, LVL_DEBUG,
+	    "udp_socket_match(sock=(%u), pat=(%u))", sock->port, patt->port);
+	
 	if ((!inet_addr_is_any(&patt->addr)) &&
 	    (!inet_addr_compare(&patt->addr, &sock->addr)))
Index: uspace/srv/net/udp/sock.c
===================================================================
--- uspace/srv/net/udp/sock.c	(revision 34847e2e27574b82c78d62e245fd620e09609132)
+++ uspace/srv/net/udp/sock.c	(revision 2921602409606b0cd4dcd19e8c8197f521e7418e)
@@ -265,4 +265,10 @@
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "udp_sock_send()");
 	
+	uint8_t *buffer = calloc(UDP_FRAGMENT_SIZE, 1);
+	if (buffer == NULL) {
+		async_answer_0(callid, ENOMEM);
+		return;
+	}
+	
 	struct sockaddr_in6 *addr6 = NULL;
 	struct sockaddr_in *addr;
@@ -276,5 +282,5 @@
 		if (rc != EOK) {
 			async_answer_0(callid, rc);
-			return;
+			goto out;
 		}
 		
@@ -357,5 +363,5 @@
 			log_msg(LOG_DEFAULT, LVL_DEBUG, "udp_sock_sendto: Failed to "
 			    "determine local address.");
-			return;
+			goto out;
 		}
 		
@@ -379,5 +385,4 @@
 			length = UDP_FRAGMENT_SIZE;
 		
-		uint8_t buffer[UDP_FRAGMENT_SIZE];
 		int rc = async_data_write_finalize(wcallid, buffer, length);
 		if (rc != EOK) {
@@ -425,4 +430,6 @@
 	if (addr6 != NULL)
 		free(addr6);
+	
+	free(buffer);
 }
 
